﻿#include <algorithm> // make_heap et sort_heap
#include <deque>
#include <iostream>
#include <vector>

#include "Heap.h"

class Task {
private:
	int _priority;
public:

	inline Task(int priority = 0) : _priority(priority) {
	};

	inline bool operator<(const Task& t) const {
		return _priority < t._priority;
	};
};

int main(int argc, char** argv) {
	std::vector<char> tab(2);
	tab[0] = 'a';
	tab[1] = 'b';
	// tab[2] = 'c'; // Out of bounds!
	tab.push_back('c'); // OK, capacity is now '3'...
	// std::cout << "Proof: " << tab[2] << std::endl;

	// for (std::vector<char>::iterator i = tab.begin(); i != tab.end(); i++) std::cout << *i << std::endl;

	// std::cout << *tab.begin() << std::endl;

	std::vector<char>::reverse_iterator ri = tab.rbegin();
	// std::cout << *ri << std::endl;

	Heap<short> my_heap;
	my_heap.insert(13);
	my_heap.insert(7);
	my_heap.insert(12);
	my_heap.insert(4);
	my_heap.insert(6);
	my_heap.insert(11);
	my_heap.insert(8);
	my_heap.insert(3);
	// my_heap.insert(9);

	short result[9];
	my_heap.sort(result);
	for (int i = 0; i < my_heap.size(); i++) std::cout << i << "(" << result[i] << ") - ";
	std::cout << std::endl;

	short my_array[] = { 3, 4, 6, 7, 8, 11, 12, 13 };
	std::vector<short> my_vector(my_array, my_array + 8);
	for (int i = 0; i < my_vector.size(); i++) std::cout << "-" << my_vector[i];
	/* Display: '-3 - 4 - 6 - 7 - 8 - 11 - 12 - 13' */
	std::cout << std::endl;
	std::make_heap(my_vector.begin(), my_vector.end());
	for (int i = 0; i < my_vector.size(); i++) std::cout << "-" << my_vector[i];
	/* Display: '- 13 - 8 - 12 - 7 - 3 - 11 - 6 - 4' */
	std::cout << std::endl;
	std::sort_heap(my_vector.begin(), my_vector.end());
	for (int i = 0; i < my_vector.size(); i++) std::cout << "-" << my_vector[i];
	/* Display: '-3 - 4 - 6 - 7 - 8 - 11 - 12 - 13' */
	std::cout << std::endl;

	Priority_queue<Task, 100, std::deque<Task> > priority_queue;
	Task t1(1), t2(2), t3(3);
	priority_queue.insert(t1);
	priority_queue.insert(t2);
	priority_queue.insert(t3);
	Heap_representation_size_type<std::deque<Task> > count = priority_queue.count();
	std::cout << "count: " << count << std::endl;

	return 0;
}
